"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDisableIntrospection = useDisableIntrospection;
const graphql_1 = require("graphql");
const promise_helpers_1 = require("@whatwg-node/promise-helpers");
function useDisableIntrospection(props) {
    const store = new WeakMap();
    return {
        onRequestParse({ request, serverContext }) {
            return (0, promise_helpers_1.handleMaybePromise)(() => (props?.isDisabled ? props.isDisabled(request, serverContext) : true), () => {
                store.set(request, true);
            });
        },
        onValidate({ addValidationRule, context }) {
            const isDisabled = store.get(context.request) ?? true;
            if (isDisabled) {
                addValidationRule(graphql_1.NoSchemaIntrospectionCustomRule);
            }
        },
    };
}
