import { NoSchemaIntrospectionCustomRule } from 'graphql';
import { handleMaybePromise } from '@whatwg-node/promise-helpers';
export function useDisableIntrospection(props) {
    const store = new WeakMap();
    return {
        onRequestParse({ request, serverContext }) {
            return handleMaybePromise(() => (props?.isDisabled ? props.isDisabled(request, serverContext) : true), () => {
                store.set(request, true);
            });
        },
        onValidate({ addValidationRule, context }) {
            const isDisabled = store.get(context.request) ?? true;
            if (isDisabled) {
                addValidationRule(NoSchemaIntrospectionCustomRule);
            }
        },
    };
}
